3 USAGE='[start|bad|good|next|reset|visualize|replay|log|run]'
4 LONG_USAGE='git bisect start [<bad> [<good>...]] [--] [<pathspec>...]
5 reset bisect state and start bisection.
7 mark <rev> a known-bad revision.
8 git bisect good [<rev>...]
9 mark <rev>... known-good revisions.
11 find next bisection to test and check it out.
12 git bisect reset [<branch>]
13 finish bisection search and go back to branch.
15 show bisect status in gitk.
16 git bisect replay <logfile>
20 git bisect run <cmd>...
21 use <cmd>... to automatically bisect.'
29 s/'\''/'\'\\\\\'\''/g;
37 test -d "$GIT_DIR/refs/bisect" || {
38 echo >&2 'You need to start by "git bisect start"'
41 echo >&2 -n 'Do you want me to do it for you [Y/n]? '
56 # Verify HEAD. If we were bisecting before this, reset to the
57 # top-of-line master first!
59 head=$(GIT_DIR="$GIT_DIR" git-symbolic-ref HEAD) ||
60 die "Bad HEAD - I need a symbolic ref"
63 if [ -s "$GIT_DIR/head-name" ]; then
64 branch=`cat "$GIT_DIR/head-name"`
68 git checkout $branch || exit
71 [ -s "$GIT_DIR/head-name" ] && die "won't bisect on seeked tree"
72 echo "$head" | sed 's#^refs/heads/##' >"$GIT_DIR/head-name"
75 die "Bad HEAD - strange symbolic ref"
80 # Get rid of any old bisect state
83 mkdir "$GIT_DIR/refs/bisect"
86 # Check for one bad and then some good revisions.
90 case "$arg" in --) has_double_dash=1; break ;; esac
94 while [ $# -gt 0 ]; do
102 rev=$(git-rev-parse --verify "$arg^{commit}" 2>/dev/null) || {
103 test $has_double_dash -eq 1 &&
104 die "'$arg' does not appear to be a valid revision"
107 if [ $bad_seen -eq 0 ]; then
109 bisect_write_bad "$rev"
111 bisect_write_good "$rev"
118 sq "$@" >"$GIT_DIR/BISECT_NAMES"
120 printf "git-bisect start"
122 } >>"$GIT_DIR/BISECT_LOG"
130 rev=$(git-rev-parse --verify HEAD) ;;
132 rev=$(git-rev-parse --verify "$1^{commit}") ;;
136 bisect_write_bad "$rev"
137 echo "git-bisect bad $rev" >>"$GIT_DIR/BISECT_LOG"
143 echo "$rev" >"$GIT_DIR/refs/bisect/bad"
144 echo "# bad: "$(git-show-branch $rev) >>"$GIT_DIR/BISECT_LOG"
150 0) revs=$(git-rev-parse --verify HEAD) || exit ;;
151 *) revs=$(git-rev-parse --revs-only --no-flags "$@") &&
152 test '' != "$revs" || die "Bad rev input: $@" ;;
156 rev=$(git-rev-parse --verify "$rev^{commit}") || exit
157 bisect_write_good "$rev"
158 echo "git-bisect good $rev" >>"$GIT_DIR/BISECT_LOG"
164 bisect_write_good() {
166 echo "$rev" >"$GIT_DIR/refs/bisect/good-$rev"
167 echo "# good: "$(git-show-branch $rev) >>"$GIT_DIR/BISECT_LOG"
170 bisect_next_check() {
172 test -f "$GIT_DIR/refs/bisect/bad" &&
173 case "$(cd "$GIT_DIR" && echo refs/bisect/good-*)" in
174 refs/bisect/good-\*) ;;
177 case "$next_ok,$1" in
181 test -d "$GIT_DIR/refs/bisect" || {
182 echo >&2 'You need to start by "git bisect start".'
185 echo >&2 'You '$THEN'need to give me at least one good' \
186 'and one bad revisions.'
187 echo >&2 '(You can use "git bisect bad" and' \
188 '"git bisect good" for that.)'
196 bisect_next_check && bisect_next || :
200 case "$#" in 0) ;; *) usage ;; esac
202 bisect_next_check fail
203 bad=$(git-rev-parse --verify refs/bisect/bad) &&
204 good=$(git-rev-parse --sq --revs-only --not \
205 $(cd "$GIT_DIR" && ls refs/bisect/good-*)) &&
206 rev=$(eval "git-rev-list --bisect $good $bad -- $(cat "$GIT_DIR/BISECT_NAMES")") || exit
207 if [ -z "$rev" ]; then
208 echo "$bad was both good and bad"
211 if [ "$rev" = "$bad" ]; then
212 echo "$rev is first bad commit"
213 git-diff-tree --pretty $rev
216 nr=$(eval "git-rev-list $rev $good -- $(cat $GIT_DIR/BISECT_NAMES)" | wc -l) || exit
217 echo "Bisecting: $nr revisions left to test after this"
218 echo "$rev" > "$GIT_DIR/refs/heads/new-bisect"
219 git checkout -q new-bisect || exit
220 mv "$GIT_DIR/refs/heads/new-bisect" "$GIT_DIR/refs/heads/bisect" &&
221 GIT_DIR="$GIT_DIR" git-symbolic-ref HEAD refs/heads/bisect
222 git-show-branch "$rev"
226 bisect_next_check fail
227 not=`cd "$GIT_DIR/refs" && echo bisect/good-*`
228 eval gitk bisect/bad --not $not -- $(cat "$GIT_DIR/BISECT_NAMES")
233 0) if [ -s "$GIT_DIR/head-name" ]; then
234 branch=`cat "$GIT_DIR/head-name"`
238 1) git-show-ref --verify --quiet -- "refs/heads/$1" || {
239 echo >&2 "$1 does not seem to be a valid branch"
246 if git checkout "$branch"; then
247 rm -f "$GIT_DIR/head-name"
252 bisect_clean_state() {
253 rm -fr "$GIT_DIR/refs/bisect"
254 rm -f "$GIT_DIR/refs/heads/bisect"
255 rm -f "$GIT_DIR/BISECT_LOG"
256 rm -f "$GIT_DIR/BISECT_NAMES"
257 rm -f "$GIT_DIR/BISECT_RUN"
262 echo >&2 "cannot read $1 for replaying"
266 while read bisect command rev
268 test "$bisect" = "git-bisect" || continue
271 cmd="bisect_start $rev"
275 echo "$rev" >"$GIT_DIR/refs/bisect/good-$rev"
276 echo "# good: "$(git-show-branch $rev) >>"$GIT_DIR/BISECT_LOG"
277 echo "git-bisect good $rev" >>"$GIT_DIR/BISECT_LOG"
280 echo "$rev" >"$GIT_DIR/refs/bisect/bad"
281 echo "# bad: "$(git-show-branch $rev) >>"$GIT_DIR/BISECT_LOG"
282 echo "git-bisect bad $rev" >>"$GIT_DIR/BISECT_LOG"
285 echo >&2 "?? what are you talking about?"
293 bisect_next_check fail
301 # Check for really bad run error.
302 if [ $res -lt 0 -o $res -ge 128 ]; then
303 echo >&2 "bisect run failed:"
304 echo >&2 "exit code $res from '$@' is < 0 or >= 128"
308 # Use "bisect_good" or "bisect_bad"
309 # depending on run success or failure.
310 if [ $res -gt 0 ]; then
311 next_bisect='bisect_bad'
313 next_bisect='bisect_good'
316 # We have to use a subshell because bisect_good or
317 # bisect_bad functions can exit.
318 ( $next_bisect > "$GIT_DIR/BISECT_RUN" )
321 cat "$GIT_DIR/BISECT_RUN"
323 if [ $res -ne 0 ]; then
324 echo >&2 "bisect run failed:"
325 echo >&2 "$next_bisect exited with error code $res"
329 if grep "is first bad commit" "$GIT_DIR/BISECT_RUN" > /dev/null; then
330 echo "bisect run success"
352 # Not sure we want "next" at the UI level anymore.
355 bisect_visualize "$@" ;;
359 bisect_replay "$@" ;;
361 cat "$GIT_DIR/BISECT_LOG" ;;